print("start")
import gc
from FreeMemInfo import meminfostr, _print_mem_free
_print_mem_free("mem000:")
#_print_mem_free("mem001:")
import soundstuff
#_print_mem_free("mem002:")
import time
#_print_mem_free("mem003:")
import board
#_print_mem_free("mem004:")
#import usb_cdc
#_print_mem_free("mem005:")
from analogio import AnalogIn
#_print_mem_free("mem006:")
from digitalio import DigitalInOut, Direction, Pull
#_print_mem_free("mem007:")
from connectionchecker import ConnectionChecker
#_print_mem_free("mem010:")
from _bleio import adapter
#_print_mem_free("mem020:")
from adafruit_ble import BLERadio
#_print_mem_free("mem030:")
from adafruit_ble.advertising.standard import ProvideServicesAdvertisement
_print_mem_free("mem040:")
from adafruit_ble.services.nordic import UARTService
_print_mem_free("mem041:")
from adafruit_ble.services.standard.hid import DEFAULT_HID_DESCRIPTOR
#_print_mem_free("mem042:")
from adafruit_ble.services.standard.hid import HIDService
#_print_mem_free("mem043:")
# from adafruit_ble.services.standard.device_info import DeviceInfoService
#_print_mem_free("mem050:")
from adafruit_hid.keyboard import Keyboard
#_print_mem_free("mem051:")
from adafruit_hid.mouse import Mouse
#_print_mem_free("mem060:")
from adafruit_hid.consumer_control import ConsumerControl
#_print_mem_free("mem061:")
from adafruit_hid.keycode import Keycode
#_print_mem_free("mem062:")
from adafruit_hid.keyboard_layout import KeyboardLayout
#_print_mem_free("mem07:")
from BrailleInput_Table import brailleinputtable
_print_mem_free("mem08:")
from commandfunctions import CommandFunctions
#_print_mem_free("mem09:")
from commandhandler import CommandHandler
#_print_mem_free("mem10:")
from braillekeyboard import BrailleKeyboard
#_print_mem_free("mem11:")
from batterymonitor import BatteryMonitor
_print_mem_free("mem12:")


class HIDKeyboard:
    def __init__(self, hcc: ConnectionChecker, hid, hidbrl):
        self.hcc = hcc
        self.k = Keyboard(hid.devices)
        self.cc = ConsumerControl(hid.devices)
        self.mouse = Mouse(hid.devices)
        # self.brailledisplay = BrailleDisplay(hid.devices)
        self.keycount = 0
        self.keyboardlayout = ""
        self.kl = KeyboardLayout(self.k)
        self.keydelay = 0.01
        gc.collect()

    def sendchar(self, c):
        self.keycount += 1
        print(f"{self.keycount} sendchar {c}", end="")  # for debug in REPL
        #if usb_cdc.data is not None:
        #    if usb_cdc.data.connected:
        #        usb_cdc.data.write(f"sendchar {c}".encode("UTF-8"))
        if self.hcc.isconnected:
            self.kl.write(c)
            print("to keyboard ", end="")
        else:
            print("no keyboard", end="")
        print()

    def sendstr(self, s):
        self.keycount += 1
        print(f"{self.keycount} Sendstr {s}", end="")  # for debug in REPL
        if self.hcc.isconnected:
            try:
                self.kl.write(s)
            except Exception as e:
                print()
                print("Error:", str(e))
                print("code:", s)
            print("to keyboard ", end="")
        else:
            print("no keyboard", end="")
        print()

    def press(self, key):
        if self.hcc.isconnected:
            # print("keycode", key, hex(key))
            self.k.press(key)
        else:
            pass
            # print("not connected ", key, hex(key))

    def singlekey(self, key):
        if self.hcc.isconnected:
            # print("keycode", key)
            self.k.press(key)
            self.k.release_all()
        else:
            pass
            # print("not connected ", key, time.monotonic())

    def keycombo(self, keytuple):
        for key in keytuple:
            # print("press:", key)
            self.k.press(key)
        # print("release all")
        self.k.release_all()

    def release_all(self):
        self.k.release_all()

    def send_cc(self, code):
        self.cc.send(code)

    def press_and_delay(self, hidkey):
        self.press(hidkey)
        time.sleep(self.keydelay)

    def release_and_delay(self, hidkey):
        self.k.release(hidkey)
        time.sleep(self.keydelay)

    def key(self, hidkey, commandstr="", secondkey=None, optionkey=False, controlkey=False, shiftkey=False,
            commandkey=False, leftalt=False, rightalt=False, insert=False, capslock=False,
            voiceover=False, jaws=False, nvda=False):
        pp = 1
        try:
            if voiceover:
                optionkey = True
                controlkey = True
            if jaws:
                insert = True
            if nvda:
                capslock = True
            if len(commandstr):
                pass
                # print("key:", commandstr, hex(hidkey), "sh= ", optionkey, controlkey, shiftkey, commandkey, insert, capslock, secondkey)
            if optionkey:
                self.press_and_delay(Keycode.OPTION)
            if controlkey:
                self.press_and_delay(Keycode.CONTROL)
            if shiftkey:
                self.press_and_delay(Keycode.SHIFT)
            if commandkey:
                self.press_and_delay(Keycode.COMMAND)
            if leftalt:
                self.press_and_delay(Keycode.LEFT_ALT)
            if rightalt:
                self.press_and_delay(Keycode.RIGHT_ALT)

            if insert:
                self.press_and_delay(Keycode.INSERT)
            if capslock:
                self.press_and_delay(Keycode.CAPS_LOCK)
            self.press_and_delay(hidkey)
            self.release_and_delay(hidkey)
            if secondkey is not None:
                self.press_and_delay(secondkey)
                self.release_and_delay(secondkey)
            pp = 7
            self.release_all()
            pp = 8
            # print("key exit")
        except Exception as e:
            print("Error key:", str(e), pp)

    def tapandhold(self):
        delay = 0.01
        self.press(Keycode.OPTION)
        time.sleep(delay)
        self.press(Keycode.CONTROL)
        time.sleep(delay)
        self.press(Keycode.SPACEBAR)


class KeyboardApp:
    def __init__(self, globaldata):
        #_print_mem_free("mem15:")
        self.ble = None
        self.hid = None
        self.uart = None
        self.pwd = ""
        self.act_time = time.monotonic()
        self.bat_time = self.act_time + 1
        self.time_now = 0
        self.time_1000ms = 0
        self.time_10s = 0
        self.hid_time = 0
        self.uart_time = 0
        self.timesum = 0
        self.timeanf = 0
        self.timeend = 0
        self.timedif = 0
        self.timeavg = 0
        self.loopcnt = 0
        self.devicename = ""
        self.deviceowner = ""
        self.globaldata = globaldata

    def load_devicename(self):
        print("load_devicename")
        try:
            with open("/user_name.txt", "rt") as textfile:
                namelines = textfile.readlines()
                # print(namelines)
            ownername = namelines[0]
            ownername = ownername.rstrip("\n")
            ownername = ownername.rstrip("\r")
            ownername = ownername.rstrip("\n")
            if len(ownername) > 0:
                self.deviceowner = " von " + ownername
            # print("deviceowner", type(self.deviceowner), self.deviceowner)
        except Exception as e:
            print("Error:", str(e))
            soundstuff.playsound(self.globaldata.loadusernameerrortone)

    def load_password(self):
        try:
            with open("/user_password.txt", "rt") as textfile:
                pwdlines = textfile.readlines()
                # print(pwdlines)
            self.pwd = pwdlines[0].strip()
            # print("password", type(self.pwd), self.pwd)
            ok = True
            for c in self.pwd:
                if c.isdigit():
                    continue
                if c == " ":
                    continue
                if c == ",":
                    continue
                if c == "<":
                    continue
                ok = False
            if not ok:
                soundstuff.playsound(self.globaldata.userpassworderrortone)
        except Exception as s:
            print(s)
            soundstuff.playsound(self.globaldata.loaduserpassworderrortone)
            self.pwd = ""

    def init(self):
        #_print_mem_free("mem16:")
        self.commandfunctions = CommandFunctions(self.globaldata)
        self.devicename = self.globaldata.devicename
        self.deviceowner = " " + self.globaldata.deviceby + " " + self.globaldata.devicemanufacturer
        self.pwd = ""
        self.load_password()
        self.load_devicename()
        self.devicename += self.deviceowner
        if len(self.devicename) > 26:
            self.devicename = self.devicename[0:26]
        #_print_mem_free("mem17:")


        # self.hidbrl = HIDService(hid_descriptor=BRAILLE_HID_DESCRIPTOR)
        # print("BrailleHID!!!!!" )
        # device_info = DeviceInfoService(software_revision=adafruit_ble.__version__, manufacturer="Adafruit Industries")

        self.uart = UARTService()
        self.UARTadvertisement = ProvideServicesAdvertisement(self.uart)

        self.hid = HIDService(hid_descriptor=DEFAULT_HID_DESCRIPTOR)
        self.HIDadvertisement = ProvideServicesAdvertisement(self.hid)
        self.HIDadvertisement.appearance = 961
        # HIDadvertisement.short_name = "Delight"
        # HIDadvertisement.complete_name = devicename
        # adapter.name = devicename

        print("_bleio", type(adapter), adapter.name)
        self.ble = BLERadio()
        self.ble.name = self.devicename
        print("Name:", type(self.ble), self.ble.name)


        self.HIDconnectionchecker = ConnectionChecker("HID", self.ble, self.HIDadvertisement, self.globaldata)
        #self.UARTconnectionchecker = ConnectionChecker("UART", self.ble, self.UARTadvertisement)

        self.keyboard = HIDKeyboard(self.HIDconnectionchecker, self.hid, None)

        self.batt = AnalogIn(board.D10)
        # self.led1 =  AnalogIn(board.D11)
        # self.led2 = DigitalInOut(board.D2)
        # soundstuff.playsound((659, 689, 880))
        self.batterymonitor = BatteryMonitor(60)

        #_print_mem_free("mem18:")
        self.braillekeyboard = BrailleKeyboard(self.globaldata)
        self.commandhandler = CommandHandler(self.keyboard, self.commandfunctions, self.braillekeyboard, self.globaldata)
        self.commandfunctions.prepare(self.keyboard, self.pwd, self.ble, self.HIDconnectionchecker, self.batterymonitor)
        self.commandfunctions.reload()
        self.commandfunctions.commandhandler = self.commandhandler
        self.commandfunctions.braillekeyboard = self.braillekeyboard
        _print_mem_free("mem19:")

    def getcommand(self, last_key):
        try:
            last_hex = brailleinputtable.combo2hex(last_key)
            print("-----getcommand4key:", last_key, last_hex, "-> ", end="")
            command = brailleinputtable.getcommand(last_hex)
            print(" command:"+str(command)+"~", end="")
            if command == " ":
                print(" ======= space =======", end="")
            print()
            return command
        except KeyError as e:
            print("Error getcommand:", type(e), e.args, str(e), last_key)
            return False

    def work(self):
        _print_mem_free("mem20:")
        lasttime = time.monotonic()
        while True:
            self.act_time = time.monotonic()
            self.braillekeyboard.checkkeys()
            currtime = time.monotonic()
            if abs(currtime-lasttime) > 1:
                self.HIDconnectionchecker.check()
                lasttime = currtime
            #self.UARTconnectionchecker.check()
            self.braillekeyboard.checkkeys()
            if self.HIDconnectionchecker.isconnected:
                in_waiting = self.uart.in_waiting
                if in_waiting > 0:
                    uartdata = self.uart.read(in_waiting)
                    print("uart:", uartdata)
                    testdata = "hallo\n"
                    self.uart.write(testdata)
                if self.act_time - self.time_1000ms >= 1:
                    self.time_1000ms = self.act_time
                    volt = f" {self.batterymonitor.avgvalue} {self.batterymonitor.trend}  {self.batterymonitor.ref}\n"
                    self.uart.write(volt)
                if self.act_time - self.hid_time >= 10:
                    self.hid_time = self.act_time
                    self.braillekeyboard.checkkeys()
                    print("hid OK", meminfostr(True), "adv:" + str(self.ble.advertising),
                          self.braillekeyboard.checkcount, self.HIDconnectionchecker.currentconnectionid,
                          self.batterymonitor.avgvalue, self.batterymonitor.trend)
                    self.braillekeyboard.checkcount = 0
                    self.braillekeyboard.checkkeys()
                    if False:
                            i = 0
                            for d in self.hid.devices:
                                i += 1
                                print(f"{i}. hid dev:", str(d))
                            self.braillekeyboard.checkkeys()
            else:
                if self.act_time - self.hid_time >= 10:
                    self.hid_time = self.act_time
                    print("hid nc.", self.hid_time, meminfostr(True))

            self.timeanf = time.monotonic_ns()
            if self.braillekeyboard.getkey():
                # self.uart.write(self.braillekeyboard.last_key)
                # self.braillekeyboard.checkkeys()
                if False:
                    print(self.braillekeyboard.last_key)
                else:
                    command = self.getcommand(self.braillekeyboard.last_key)
                    if command:
                        self.commandhandler.execute(self.braillekeyboard.last_key, command)
                    else:
                        # case only for Testmode, nothing will be send for ""
                        self.commandhandler.execute(self.braillekeyboard.last_key, "")
                self.braillekeyboard.checkkeys()
            self.commandhandler.backgroundcall()
            self.commandfunctions.backgroundcall()
            self.braillekeyboard.checkkeys()

            self.time_now = time.monotonic()
            if self.time_now - self.time_10s > 10:
                self.time_10s = self.time_now
            self.timeend = time.monotonic_ns()
            self.loopcnt += 1
            self.timedif = self.timeend - self.timeanf
            self.timesum += self.timedif
            self.timeavg = self.timesum / self.loopcnt
            if self.act_time - self.bat_time > 0.1:
                self.bat_time = self.act_time
                self.batterymonitor.addvalue(self.batt.value, self.batt.reference_voltage)
                # volt = f" {self.batterymonitor.avgvalue} {self.batterymonitor.trend}  {self.batterymonitor.ref}\n"
                # volt = volt.rstrip()
                # print("volt:", volt)
            pass
